t5800: point out that deleting branches does not work
[git/dscho.git] / t / perf / perf-lib.sh
blob5580c22812be1cadd6b70974eb85ce7cda1b8df3
1 #!/bin/sh
3 # Copyright (c) 2011 Thomas Rast
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # do the --tee work early; it otherwise confuses our careful
19 # GIT_BUILD_DIR mangling
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 TEST_DIRECTORY=$(pwd)/..
35 TEST_OUTPUT_DIRECTORY=$(pwd)
36 if test -z "$GIT_TEST_INSTALLED"; then
37 perf_results_prefix=
38 else
39 perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
40 # make the tested dir absolute
41 GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
44 TEST_NO_CREATE_REPO=t
46 . ../test-lib.sh
48 # Variables from test-lib that are normally internal to the tests; we
49 # need to export them for test_perf subshells
50 export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
52 perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
53 mkdir -p "$perf_results_dir"
54 rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
56 if test -z "$GIT_PERF_REPEAT_COUNT"; then
57 GIT_PERF_REPEAT_COUNT=3
59 die_if_build_dir_not_repo () {
60 if ! ( cd "$TEST_DIRECTORY/.." &&
61 git rev-parse --build-dir >/dev/null 2>&1 ); then
62 error "No $1 defined, and your build directory is not a repo"
66 if test -z "$GIT_PERF_REPO"; then
67 die_if_build_dir_not_repo '$GIT_PERF_REPO'
68 GIT_PERF_REPO=$TEST_DIRECTORY/..
70 if test -z "$GIT_PERF_LARGE_REPO"; then
71 die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
72 GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
75 test_perf_create_repo_from () {
76 test "$#" = 2 ||
77 error "bug in the test script: not 2 parameters to test-create-repo"
78 repo="$1"
79 source="$2"
80 source_git=$source/$(cd "$source" && git rev-parse --git-dir)
81 mkdir -p "$repo/.git"
83 cd "$repo/.git" &&
84 { cp -Rl "$source_git/objects" . 2>/dev/null ||
85 cp -R "$source_git/objects" .; } &&
86 for stuff in "$source_git"/*; do
87 case "$stuff" in
88 */objects|*/hooks|*/config)
91 cp -R "$stuff" . || break
93 esac
94 done &&
95 cd .. &&
96 git init -q &&
97 mv .git/hooks .git/hooks-disabled 2>/dev/null
98 ) || error "failed to copy repository '$source' to '$repo'"
101 # call at least one of these to establish an appropriately-sized repository
102 test_perf_default_repo () {
103 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
105 test_perf_large_repo () {
106 if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
107 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
108 echo "warning: This will work, but may not be a sufficiently large repo" >&2
109 echo "warning: for representative measurements." >&2
111 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
113 test_checkout_worktree () {
114 git checkout-index -u -a ||
115 error "git checkout-index failed"
118 # Performance tests should never fail. If they do, stop immediately
119 immediate=t
121 test_run_perf_ () {
122 test_cleanup=:
123 test_export_="test_cleanup"
124 export test_cleanup test_export_
125 /usr/bin/time -f "%E %U %S" -o test_time.$i "$SHELL" -c '
126 . '"$TEST_DIRECTORY"/test-lib-functions.sh'
127 test_export () {
128 [ $# != 0 ] || return 0
129 test_export_="$test_export_\\|$1"
130 shift
131 test_export "$@"
133 '"$1"'
134 ret=$?
135 set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
136 exit $ret' >&3 2>&4
137 eval_ret=$?
139 if test $eval_ret = 0 || test -n "$expecting_failure"
140 then
141 test_eval_ "$test_cleanup"
142 . ./test_vars || error "failed to load updated environment"
144 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
145 echo ""
147 return "$eval_ret"
151 test_perf () {
152 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
153 test "$#" = 2 ||
154 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
155 export test_prereq
156 if ! test_skip "$@"
157 then
158 base=$(basename "$0" .sh)
159 echo "$test_count" >>"$perf_results_dir"/$base.subtests
160 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
161 if test -z "$verbose"; then
162 echo -n "perf $test_count - $1:"
163 else
164 echo "perf $test_count - $1:"
166 for i in $(seq 1 $GIT_PERF_REPEAT_COUNT); do
167 say >&3 "running: $2"
168 if test_run_perf_ "$2"
169 then
170 if test -z "$verbose"; then
171 echo -n " $i"
172 else
173 echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
175 else
176 test -z "$verbose" && echo
177 test_failure_ "$@"
178 break
180 done
181 if test -z "$verbose"; then
182 echo " ok"
183 else
184 test_ok_ "$1"
186 base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
187 "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
189 echo >&3 ""
192 # We extend test_done to print timings at the end (./run disables this
193 # and does it after running everything)
194 test_at_end_hook_ () {
195 if test -z "$GIT_PERF_AGGREGATING_LATER"; then
196 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
200 test_export () {
201 export "$@"